<template>
  <div id="Transfer" class="modalBox" @click="outTransfer($event)">
    <div class="modal">
      <div id="transferBox" class="center">
        <div class="row justify-align-center modal-title blue">
          <p>{{ gameTitle }}</p>
          <i class="fas fa-times" @click="hideTransfer()"></i>
        </div>
        <div class="modal-text2">
          <div class="modal_content">
            <div class="item row justify-align-center wrap">
              <div>主錢包額度:</div>
              <div id="master">載入中...</div>
            </div>
            <div class="item row justify-align-center wrap">
              <div>
                <span>{{ gameTitle2 }}</span
                >額度:
              </div>
              <div id="gameWallet">載入中...</div>
            </div>
            <div v-if="!btnErrorShow" class="amount">
              <div class="input-block">
                <input type="tel" placeholder="金額" class="gameamount" v-model="gameamount" />
              </div>
            </div>
          </div>
          <div v-if="!btnErrorShow" class="modal_btn">
            <button class="btn_toggle toGame" @click="toGame()" disabled>
              直接進入遊戲
            </button>
            <button
              class="btn_toggle toTransfer"
              @click="chktransfer()"
              disabled
            >
              轉點後進入遊戲
            </button>
          </div>
          <div v-if="btnErrorShow" class="game_error" @click="hideTransfer()">
            關閉
          </div>
        </div>
      </div>
    </div>
  </div>
</template> 

<script>
let isNum = /^[0-9]+$/;
module.exports = {
  data() {
    return {
      gameTitle: "",
      gameTitle2: "",
      gameHall: "",
      gameCode: "",
      gamehallcode: "",
      gameamount: "",
      btnErrorShow: false,
      titleMap: {
        'QT': 'QT電子',
        'EvoPlay': 'evo電子',
        'GR': '好路棋牌',
        'BNG': 'BNG電子',
        'LG': '幸運棋牌',
        'SP': 'SIMPLEPLAY電子',
        'CG': 'CG電子',
        'RSG': 'RSG電子',
        'AESlot': 'Ameba電子',
        'OBSlot': 'DB電子',
        'ATG': 'ATG電子',
        'FGQP': 'FG棋牌',
        'DS': '斑馬電子'
      }
    };
  },
  watch: {
    gameamount() {
      if (!isNum.test(this.gameamount)) this.gameamount = this.gameamount.substring(0, this.gameamount.length - 1);
    },
  },
  mounted() {},
  methods: {
    //關閉視窗
    outTransfer(event) {
      if (!$(event.target).closest("#transferBox").length) {
        $(`#Transfer .modal>div`).removeClass("active");
        setTimeout(function() {
          $("body").removeClass("hide");
          $("#Transfer").hide();
        }, 300)
        $(".gameamount").removeClass('error-focus')
        this.gameamount = "";
      }
    },
    hideTransfer() {
      $(`#Transfer .modal>div`).removeClass("active");
      setTimeout(function() {
        $("body").removeClass("hide");
        $("#Transfer").hide();
      }, 300)
      $(".gameamount").removeClass('error-focus')
      this.gameamount = "";
    },
    //直接進入遊戲
    toGame() {
      if (this.gameCode) window.open(`/GameLobby?g=${this.gamehallcode}&c=${this.gameCode}&p=web&l=zh-cn`);
      else window.open("/GameLobby?g=" + this.gamehallcode);
      $(`#Transfer .modal>div`).removeClass("active");
      setTimeout(function() {
        $("body").removeClass("hide");
        $("#Transfer").hide();
      }, 300)
      $(".gameamount").removeClass('error-focus')
      this.gameamount = "";
    },
    //轉點後進入遊戲
    chktransfer() {
      if (this.gameamount == "") {
        $(".gameamount").addClass('error-focus').focus()
        Swal.fire("金額不能為空", "", "error")
      }
      else {
        this.transferToGame(this.gamehallcode, this.gameamount);
      }
    },
    transferToGame(hallcode, amount) {
      $(".loading_block").show();
      axios.post(
          "../../member_act.php",
          Qs.stringify({
            a: "saveTransfer",
            from: "Master",
            to: hallcode,
            amount: amount,
          })
        )
        .then((res) => {
          if (res.data.success == 0) {
            // 轉點後進入遊戲
            if (this.gameCode) {
              Swal.fire({
                title: "轉點成功",
                text: "",
                icon: "success",
                confirmButtonText: "進入遊戲",
              }).then((result) => {
                if (result.isConfirmed) {
                  window.open(
                    `/GameLobby?g=${hallcode}&c=${this.gameCode}&p=web&l=zh-cn`
                  );
                }
              });
            } else {
              Swal.fire({
                title: "轉點成功",
                text: "",
                icon: "success",
                confirmButtonText: "進入遊戲",
              }).then((result) => {
                if (result.isConfirmed) {
                  window.open("/GameLobby?g=" + hallcode);
                }
              });
            }
            $(`#Transfer .modal>div`).removeClass("active");
            setTimeout(function() {
              $("body").removeClass("hide");
              $("#Transfer").hide();
            }, 300)
            $(".gameamount").removeClass('error-focus')
            this.gameamount = "";
          } else {
            switch (res.data.success) {
              case -99999:
              case -9999:
                if (this.$root.logintype) {
                  this.$root.logintype = false;
                  Swal.fire(res.data.msg, "", "error").then(function () {
                    location.href = "/logout";
                  });
                }
                break;
              default:
                Swal.fire(res.data.msg, "", "error");
                break;
            }
          }
          $(".loading_block").fadeOut();
        })
        .catch((err) => {
        });
    },

    //開通遊戲帳號
    confirmPlayer(name, gameHall, gameCode) {
      this.gameTitle = name;
      this.gameTitle2 = this.titleMap[gameHall] || this.gameTitle
      this.gameHall = gameHall;
      this.gameCode = gameCode;
      $(`#master`).text("載入中...");
      $(`#gameWallet`).text("載入中...");
      this.btnErrorShow = false;
      axios.post(
          "../../member_act.php",
          Qs.stringify({
            a: "confirmPlayer",
            h: gameHall,
          })
        )
        .then((res) => {
          if (res.data.success == 0) {
            this.getbalance(gameHall);
          } else {
            switch (res.data.success) {
              case -99999:
              case -9999:
                if (this.$root.logintype) {
                    this.$root.logintype = false;
                    Swal.fire(res.data.msg, '', 'error').then(function () {
                        location.href = './logout';
                        $('.loading_block').show();
                    })
                }
                break;
              case -2:
                this.gameError('遊戲維護中')
                break;
              case -3:
                this.gameError('遊戲尚未開放')
                break;
              default:
                this.gameError('失敗')
                break;
            }
          }
        })
        .catch((err) => {
          this.gameError('失敗')
        });
    },
    getbalance(hallcode) {
      $(".modal_btn>button").addClass("btn_toggle").attr("disabled", true);
      let wallet = hallcode == "Master" ? "master" : "gameWallet";
      if (hallcode != "Master") this.gamehallcode = hallcode;
      axios.post(
          "../../member_act.php",
          Qs.stringify({
            a: "getBalance",
            h: hallcode,
          })
        )
        .then((res) => {
          if (res.data.success == 0) {
            if (res.data.data) {
              $(`#${wallet}`).text(
                res.data.data.Balance ? res.data.data.Balance : this.gameError("失敗")
              );
              if ($("#master").text() != "載入中..." && $("#gameWallet").text() != "載入中...") {
                $(".modal_btn>button").removeClass("btn_toggle").removeAttr("disabled");
              }
            } else {
              this.gameError("連線失敗");
            }
          } else {
            switch (res.data.success) {
              case -99999:
              case -9999:
                if (this.$root.logintype) {
                    this.$root.logintype = false;
                    Swal.fire(res.data.msg, '', 'error').then(function () {
                        location.href = './logout';
                        $('.loading_block').show();
                    })
                }
                break;
              default:
                this.gameError('連線失敗')
                break;
            }
          }
        })
        .catch((err) => {
          this.gameError("連線失敗");
        });
    },
    gameError(err) {
      this.btnErrorShow = true;
      $(`#gameWallet`).text(err)
    },
  },
};
</script>
